package cn.feast.coding.service.generator;

import cn.feast.coding.mapper.generator.PageTemplateMapper;
import cn.feast.coding.model.generator.DataSource;
import cn.feast.coding.model.generator.Page;
import cn.feast.coding.model.generator.PageTemplate;
import cn.feast.coding.tools.SysContants;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created By FeastCoding.
 */
@Service
public class PageTemplateService {

    @Autowired
    private PageTemplateMapper mapper;

    public Integer save(PageTemplate pageTemplate) {
        return mapper.save(pageTemplate);
    }

    public void update(PageTemplate pageTemplate) {
        mapper.update(pageTemplate);
    }

    public void deleteById(Integer id) {
        mapper.deleteById(id);
    }

    public int queryByCount(PageTemplate pageTemplate) {
        return mapper.queryByCount(pageTemplate);
    }

    public List<PageTemplate> queryByList(Page page, PageTemplate pageTemplate) {
        String pageQueryCondition = " limit " + page.getStart() + " , " + page.getMaxRows();
        Map<String, Object> paramsMap = new HashMap<String, Object>();
        paramsMap.put("pageName", pageTemplate.getPageName());
        paramsMap.put("pagePath", pageTemplate.getPagePath());
        paramsMap.put("pageImag", pageTemplate.getPageImag());
        paramsMap.put("pageDesc", pageTemplate.getPageDesc());
        paramsMap.put("pageDefault", pageTemplate.getPageDefault());
        paramsMap.put("pageQueryCondition", pageQueryCondition);
        return mapper.queryByList(paramsMap);
    }

    public List<PageTemplate> queryByPageTemplate(PageTemplate pageTemplate) {
        return mapper.queryByPageTemplate(pageTemplate);
    }

    public PageTemplate queryById(Integer id) {
        return mapper.queryById(id);
    }

    public List<PageTemplate> queryByAll() {
        return mapper.queryAll();
    }

    public PageInfo<PageTemplate> queryPage(PageTemplate pageTemplate, int pageNum, int pageSize) {
        if (pageSize < 1)
            pageSize = SysContants.MAX_PAGE_ROWS;
        PageHelper.startPage(pageNum, pageSize);
        List<PageTemplate> list = mapper.queryByPageTemplate(pageTemplate);
        PageInfo pageInfo = new PageInfo(list);
        return pageInfo;
    }

    public List<PageTemplate> getPage(String templateType) {
        return mapper.getPage(templateType);
    }
}
